<?php
/**
 * Plugin Previsualisation etendue
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */
include_spip('inc/filtres');


/**
 * Mecanisme de previsualisation propre au plugin
 * qui permet de beneficier du cache de premier niveau de SPIP (evite la recompilation du squelette). 
 * Ajout d'une fonction dans la clause where de certaines boucles.
 * Au passage on permet de previsualiser un article en cours de redaction
 * mais pas ceux des rubriques qu'on ne doit pas voir.
 *
 * @param 	$boucle
 * @return 	$boucle
 */
// function cipr_post_boucle(&$boucle){
function cipr_post_boucle($boucle){

	if ($GLOBALS['spip_version_branche']<3) {
		if (!isset($boucle->modificateur['tout_voir'])){
			if (!test_espace_prive()) {
				$id_table = $boucle->id_table;
				$m_statut = $id_table .'.statut';
				$type_requete = $boucle->type_requete;
				$m_id_rubrique = $boucle->id_table . '.id_rubrique';
	
				if (in_array($type_requete, array('hierarchie','rubriques','articles','breves','sites','syndication','syndic_articles'))){
					// pouvoir previsualiser un article en cours de redaction, etc. 
					$search = array("'='", "'$m_statut'", "'\\'publie\\''");
					$search2 = array("'='", "'L1.statut'", "'\\'publie\\''");
					if(is_array($boucle->where)) {
					    foreach($boucle->where as $key => $value) {
					        if(is_array($value)) {
					            $tmp = array_diff_assoc($search, $value);
					            if(empty($tmp)) {
									$boucle->where[$key] = 'cipr_where(\''.$type_requete.'\',\''.$m_statut.'\',\''.$m_id_rubrique.'\')';
					            } else {
						            $tmp2 = array_diff_assoc($search2, $value);
						            if(empty($tmp2))
										$boucle->where[$key] = 'cipr_where(\''.$type_requete.'\',\'L1.statut\',\''.$m_id_rubrique.'\')';
	
					            }

					        }
					        // contenu post date
					        if(is_array($value)) {
				        		if (!empty($value[2]) AND strpos($value[2], 'quete_date_postdates')!==FALSE){
								$value[2] = str_replace('quete_date_postdates','cipr_postdates',$value[2]);
						        	$boucle->where[$key] = $value;
				        		}
					        } else {
				        		if (!empty($value) AND strpos($value, 'quete_date_postdates')!==FALSE){
						        	$boucle->where[$key] = str_replace('quete_date_postdates','cipr_postdates',$value);
                                                        }
					        }
					    }
					}
				}
				
				if ($type_requete=='documents') {
					// contourner les postdates
					$search = "OR bb.statut = \'publie\' OR rr.statut = \'publie\'";
				    if (is_array($boucle->where)) {
				        foreach($boucle->where as $key => $value) {
				            if (!is_array($value)) {
				                if(!empty($value) AND strpos($value,$search)!==false) {
				                	$value = str_replace("aa.statut = \'publie\'","aa.statut IN '.cipr_where_document('articles').'",$value);
				                	$value = str_replace("bb.statut = \'publie\'","bb.statut IN '.cipr_where_document('breves').'",$value);
				                	$value = str_replace("rr.statut = \'publie\'","rr.statut IN '.cipr_where_document('rubriques').'",$value);
									$boucle->where[$key] = $value;
				                }
				            }
				        }
				    }
				}
						
			}	
		}
		
		$boucle->hash .= "if (!defined('_DIR_PLUGIN_CIPR')){
		\$message_fr = 'La previsualisation etendue a ete desactivée. <a href=\"'.generer_url_ecrire('admin_plugin').'\">Corriger le problème</a> ou <a href=\"'.generer_url_ecrire('admin_vider').'\">vider le cache</a>.'; die(\$message_fr);
		}";
	}
	return $boucle;
}


/**
 * En mode previsualisation, affiche le logo de previsualisation
 *
 * @param 	$val
 * @return 	$val
 */
function cipr_affichage_final($val){

	if (isset($GLOBALS['visiteur_session']['statut'])) {
		
                if (defined('_VAR_PREVIEW') AND _VAR_PREVIEW) {
                        $cipage = _request('page');
                        // au passage, compatibilite avec le plugin cisf
                        if(!$cipage OR strlen($cipage)<5 OR substr($cipage,0,5)!='cisf_') {
                                $url = $GLOBALS['REQUEST_URI'];
                                $url = str_replace('var_mode=preview','',$url);
                                $url = str_replace('var_mode=cipreview','',$url);
                                $url = parametre_url($url, 'cipreview', 'non',"&");
                                if ($GLOBALS['spip_version_branche']>=4) {
                                    $x = '<a href="'.$url.'" style="text-decoration:none;">' 
                                            . '<img alt="'._T('icone_retour').'" src="'.chemin_image("supprimer-32.svg").'" style="border:none;width:32px;height:32px;"></a>';
                                } else {
                                    $x = '<a href="'.$url.'" style="text-decoration:none;">' 
                                            . '<img alt="'._T('icone_retour').'" src="'.chemin_image("supprimer-16.png").'" style="border:none;"></a>';
                                }

                                if ($pos_debut_previsu = strpos($val, "<div class='spip-previsu'")) {
                                        if ($pos_fin_previsu = strpos($val, '</div>', $pos_debut_previsu))
                                                $val = substr_replace($val, $x, $pos_fin_previsu, 0);
                                }
                        }
                }

	}
	return $val;
}


/**
 * Dans l'espace prive, afficher le bouton "previsualiser"
 * pour un article en cours de redaction et pour une rubrique publiee
 * (si la rubrique contient un article publie et un non publie,
 * cela permet de previsualiser la rubrique avec ses 2 articles) 
 *
 * @param 	$flux
 * @return 	$flux
 */
// function cipr_boite_infos(&$flux){
function cipr_boite_infos($flux){
	if ($GLOBALS['spip_version_branche']<3) {
	
		$objet = $flux['args']['type'];
		$id_objet = intval($flux['args']['id']);
		$statut = $flux['args']['row']['statut'];
		
		include_spip('inc/autoriser');
		if (autoriser('previsualiser') AND $id_objet) {
			if (($objet=='article' AND $statut == 'prepa') OR ($objet=='rubrique' AND $statut == 'publie')) {
				$url = generer_url_action('redirect', "type=$objet&id=$id_objet&var_mode=preview");
				$texte = icone_horizontale(_T('previsualiser'), $url, "racine-24.gif", "rien.gif",false);
				if ($pos = strpos($flux['data'],'</ul>')){
					if ($pos2 = strpos($flux['data'],'</ul>',$pos+5)) $pos=$pos2;
					$flux['data'] = substr($flux['data'],0,$pos+5).$texte.substr($flux['data'],$pos+5);
				} else {
					$flux['data'].= $texte;
				}
			}
		}
	}

	return $flux;
}


/**
 * Sortir du mode previsualisation lorsque l'on entre dans l'espace prive
 *
 * @param 	$val
 * @return 	$val
 */
function cipr_body_prive($val){
	// suppression du cookie
	if (isset($_COOKIE['cipr_preview']))	
		spip_setcookie('cipr_preview', '', time() - 3600);
	
	return $val;
}

/**
 * Sortir du mode previsualisation lorsque l'on entre dans le plugin CISF
 *
 * @param 	$val
 * @return 	$val
 */
function cipr_cisf_article_options($val){
	// suppression du cookie
	if (isset($_COOKIE['cipr_preview'])) {	
		include_spip('inc/cookie');
		spip_setcookie('cipr_preview', '', time() - 3600);
	}
	
	return $val;
}

?>